
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">
  <!-- xsl:template means this is executed for the entire
         XML file we're mapping. -->
  <xsl:template match="/">
    <!-- Begin displaying HTML. -->
    <!-- When using HTML in an XSL file, all opening tags must have
           closing tags or the file isn't well-formed. -->
    <html>
      <head>
        <title>Product List</title>
      </head>
      <body>
        <h1>Northwind Products</h1>

        <!-- Put the information in a table for easy viewing. -->
        <table border="1">
          <tr>
            <th>Product ID</th>
            <th>Product Name</th>
            <th>SupplierId</th>
            <th>CategoryId</th>
            <th>Quantity Per Unit</th>
            <th>UnitPrice</th>
            <th>UnitsInStock</th>
            <th>UnitsOnOrder</th>
            <th>ReOrderLevel</th>
          </tr>

          <!-- Begin processing the attributes of each products tag 
               returned, -->
          <xsl:for-each select="root/products">
            <tr>
              <!-- The following value-of statements display all the 
                   attributes returned by each products element.    -->
              <td><xsl:value-of select="@ProductID"/></td>
              <td><xsl:value-of select="@ProductName"/></td>
              <td><xsl:value-of select="@SupplierID"/></td>
              <td><xsl:value-of select="@CategoryID"/></td>
              <td><xsl:value-of select="@QuantityPerUnit"/></td>
              <td><xsl:value-of select="@UnitPrice"/></td>
              <td><xsl:value-of select="@UnitsInStock"/></td>
              <td><xsl:value-of select="@UnitsOnOrder"/></td>
              <td><xsl:value-of select="@ReorderLevel"/></td>
            </tr>
          </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
