Imports System.IO
Imports System.Text
Imports System.Xml
Imports System.Threading

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents picSmiley As System.Windows.Forms.PictureBox
    Friend WithEvents dlgXmlFile As System.Windows.Forms.OpenFileDialog
    Friend WithEvents mnuMain As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExitSep As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents btnClear As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnClear = New System.Windows.Forms.Button()
        Me.picSmiley = New System.Windows.Forms.PictureBox()
        Me.mnuFileExit = New System.Windows.Forms.MenuItem()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem()
        Me.mnuFileExitSep = New System.Windows.Forms.MenuItem()
        Me.dlgXmlFile = New System.Windows.Forms.OpenFileDialog()
        Me.mnuMain = New System.Windows.Forms.MainMenu()
        Me.SuspendLayout()
        '
        'btnClear
        '
        Me.btnClear.Location = New System.Drawing.Point(72, 168)
        Me.btnClear.Name = "btnClear"
        Me.btnClear.Size = New System.Drawing.Size(56, 23)
        Me.btnClear.TabIndex = 1
        Me.btnClear.Text = "Clear"
        '
        'picSmiley
        '
        Me.picSmiley.Location = New System.Drawing.Point(40, 24)
        Me.picSmiley.Name = "picSmiley"
        Me.picSmiley.Size = New System.Drawing.Size(128, 128)
        Me.picSmiley.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize
        Me.picSmiley.TabIndex = 0
        Me.picSmiley.TabStop = False
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 2
        Me.mnuFileExit.Text = "E&xit"
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen, Me.mnuFileExitSep, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'mnuFileExitSep
        '
        Me.mnuFileExitSep.Index = 1
        Me.mnuFileExitSep.Text = "-"
        '
        'dlgXmlFile
        '
        Me.dlgXmlFile.Filter = "XML Files (*.xml)|*.xml|All Files (*.*)|*.*"
        '
        'mnuMain
        '
        Me.mnuMain.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(200, 201)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnClear, Me.picSmiley})
        Me.Menu = Me.mnuMain
        Me.Name = "Form1"
        Me.Text = "ReadEncodedPicture"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dlgXmlFile.InitialDirectory = DataSubdirectory()
    End Sub

    ' Let the user select an XML file and open it.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        ' Present the dialog and let the user select a file.
        If dlgXmlFile.ShowDialog() = DialogResult.Cancel Then Exit Sub

        picSmiley.Image = Nothing
        Me.Cursor = Cursors.WaitCursor
        Refresh()

        ' Load the file's picture.
        Dim xml_text_reader As New XmlTextReader(dlgXmlFile.FileName)

        ' Skip until we find the Picture node.
        Do While xml_text_reader.Read()
            ' See if this is the Picture node.
            If xml_text_reader.Name = "Picture" Then
                ' Allocate room for the byte data.
                Dim num_bytes As Integer = xml_text_reader.GetAttribute("NumBytes")
                Dim bytes(num_bytes - 1) As Byte

                ' Translate the encoded data back into byte data.
                Select Case xml_text_reader.GetAttribute("Encoding").ToLower
                    Case "base64"
                        xml_text_reader.ReadBase64(bytes, 0, num_bytes)
                    Case "binhex"
                        xml_text_reader.ReadBinHex(bytes, 0, num_bytes)
                    Case Else
                        MsgBox("Unknown image encoding '" & _
                            xml_text_reader.GetAttribute("Encoding") & "'", _
                            MsgBoxStyle.Exclamation, "Unknown Encoding")
                        Exit Sub
                End Select

                ' Allocate a MemoryStream and 
                ' a BinaryWriter attached to it.
                Dim memory_stream As New MemoryStream()
                Dim binary_writer As BinaryWriter = New BinaryWriter(memory_stream)

                ' Copy the bytes into the BinaryWriter 
                ' and thus the MemoryStream.
                binary_writer.Write(bytes, 0, num_bytes)
                binary_writer.Flush()

                ' Load the picture from the memory stream.
                memory_stream.Position = 0
                picSmiley.Image = Image.FromStream(memory_stream)
                Refresh()

                binary_writer.Close()
                Exit Do
            End If
        Loop

        xml_text_reader.Close()
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        picSmiley.Image = Nothing
    End Sub
End Class
