Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents btnTotalOrders As System.Windows.Forms.Button
    Friend WithEvents txtOrders As System.Windows.Forms.TextBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnTotalOrders = New System.Windows.Forms.Button()
        Me.txtOrders = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'btnTotalOrders
        '
        Me.btnTotalOrders.Location = New System.Drawing.Point(104, 8)
        Me.btnTotalOrders.Name = "btnTotalOrders"
        Me.btnTotalOrders.Size = New System.Drawing.Size(64, 32)
        Me.btnTotalOrders.TabIndex = 0
        Me.btnTotalOrders.Text = "Total Orders"
        '
        'txtOrders
        '
        Me.txtOrders.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtOrders.Location = New System.Drawing.Point(0, 48)
        Me.txtOrders.Multiline = True
        Me.txtOrders.Name = "txtOrders"
        Me.txtOrders.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtOrders.Size = New System.Drawing.Size(272, 229)
        Me.txtOrders.TabIndex = 1
        Me.txtOrders.Text = ""
        Me.txtOrders.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(272, 277)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtOrders, Me.btnTotalOrders})
        Me.Name = "Form1"
        Me.Text = "TotalOrders"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Calculate the total of all orders.
    Private Sub btnTotalOrders_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTotalOrders.Click
        Dim xml_text_reader As XmlTextReader
        Dim results As String
        Dim order_total As Decimal
        Dim grand_total As Decimal

        ' Open the XmlTextReader.
        Dim file_name As String = DataSubdirectory() & "\Orders.xml"
        Try
            xml_text_reader = New XmlTextReader(file_name)
        Catch exc As Exception
            MsgBox("Error opening file '" & file_name & "'" & _
                vbCrLf & exc.Message())
            Exit Sub
        End Try

        ' Skip over processing instructions and other non-content nodes.
        xml_text_reader.WhitespaceHandling = WhitespaceHandling.None
        xml_text_reader.MoveToContent()

        ' The first node should be Orders.
        If xml_text_reader.Name <> "Orders" Then
            MsgBox("Error reading file '" & DataSubdirectory() & "\Orders.xml' at line number " & xml_text_reader.LineNumber.ToString & "." & _
                vbCrLf & "Found '" & xml_text_reader.Name & "' node when expecting an 'Orders' node.")
            Exit Sub
        End If

        ' Move to the next node (the first Order).
        xml_text_reader.Read()

        ' Read until we find the </Orders> tag.
        Do
            ' See what kind of node we are reading.
            ' This should be either an Order element or the
            ' closing </Orders> tag.

            If xml_text_reader.Name = "Order" Then
                ' This is an Order node. Process it.
                ' Note that GetOrderTotal moves xml_text_reader
                ' so it points to the node after </Order>.
                ' That will be either another Order element or the
                ' closing </Orders> tag.
                order_total = GetOrderTotal(xml_text_reader)

                ' Add the order total to the results.
                results = results & Format(order_total, "$#,##0.00") & vbCrLf
                grand_total = grand_total + order_total
            ElseIf xml_text_reader.Name = "Orders" Then
                ' This is the </Orders> closing tag for the document.
                ' Stop processing the file.
                xml_text_reader.Skip()
                Exit Do
            Else
                ' This should never happen.
                MsgBox("Error processing orders file. Found '" & _
                    xml_text_reader.Name & _
                    "' when expecting 'Order' or 'Orders'", _
                    MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly, _
                    "Parsing Error")
            End If
        Loop

        ' We are done reading everything. Close the file.
        xml_text_reader.Close()

        ' Display the results.
        results = results & "--------------------" & vbCrLf & _
            "Grand Total: " & Format(grand_total, "$#,##0.00")
        txtOrders.Text = results
        txtOrders.Focus()
        txtOrders.Select(txtOrders.Text.Length, 0)
        txtOrders.ScrollToCaret()
    End Sub

    ' Read this Order node and return the order total.
    Private Function GetOrderTotal(ByVal xml_text_reader As XmlTextReader)
        Dim order_total As Decimal

        ' Get the next node (the first node inside the Order).
        xml_text_reader.Read()

        ' Examine nodes until we find the </Order> closing tag.
        Do
            Select Case xml_text_reader.Name
                Case "Item"
                    ' This is an order item. 
                    ' Add its cost to the total.
                    order_total = order_total + _
                        xml_text_reader.GetAttribute("UnitPrice") * _
                        xml_text_reader.GetAttribute("Quantity")

                    ' Move to the next node.
                    xml_text_reader.Read()
                Case "Order"
                    ' This is the </Order> closing tag.
                    ' Move to the next node before we return.
                    xml_text_reader.Read()

                    ' Return the order total.
                    Return order_total
                Case Else
                    ' This is something like <Customer> that 
                    ' we want to ignore. Skip it.
                    xml_text_reader.Skip()
            End Select
        Loop
    End Function

    ' Center the button.
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        btnTotalOrders.SetBounds( _
            (ClientSize.Width - btnTotalOrders.Size.Width) / 2, _
            btnTotalOrders.Location.Y, _
            btnTotalOrders.Size.Width, _
            btnTotalOrders.Size.Height)
    End Sub
End Class
