<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>

    <!-- Root. -->
    <xsl:template match="/">
        <HTML>
        <HEAD>
        <TITLE>Authors</TITLE>
        </HEAD>
        <BODY>

        <!-- Process Author nodes. -->
        <xsl:apply-templates/>

        </BODY>
        </HTML>
    </xsl:template>

    <!-- Author. -->
    <xsl:template match="Author">
        <P>
            <!-- Get the Author node number. -->
            <xsl:variable name="AuthorNumber">
                <xsl:number/>
            </xsl:variable>

            <!-- Show the picture. -->
            <A>
                <xsl:attribute name="HREF">
                    <xsl:value-of select="WebSite"/>
                </xsl:attribute>
                <IMG>
                    <xsl:attribute name="SRC">
                        <xsl:value-of select="PictureRef"/>
                    </xsl:attribute>

                    <!-- Alternate placement of pictures. -->
                    <xsl:if test="$AuthorNumber mod 2 = 1">
                        <xsl:attribute name="ALIGN">Left</xsl:attribute>
                    </xsl:if>
                    <xsl:if test="$AuthorNumber mod 2 = 0">
                        <xsl:attribute name="ALIGN">Right</xsl:attribute>
                    </xsl:if>

                    <xsl:attribute name="ALT">
                        <xsl:value-of select="FirstName"/>
                        <xsl:text> </xsl:text>
                        <xsl:value-of select="LastName"/>
                    </xsl:attribute>
                </IMG>
            </A>

            <!-- Show the biographical text. -->
            <xsl:value-of select="Bio"/>
        </P>
    </xsl:template>

</xsl:stylesheet>
