Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents lstOrders As System.Windows.Forms.ListBox
    Friend WithEvents lvwOrder As System.Windows.Forms.ListView
                                                                                                                                
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lvwOrder = New System.Windows.Forms.ListView()
        Me.lstOrders = New System.Windows.Forms.ListBox()
        Me.SuspendLayout()
        '
        'lvwOrder
        '
        Me.lvwOrder.Location = New System.Drawing.Point(136, 8)
        Me.lvwOrder.Name = "lvwOrder"
        Me.lvwOrder.Size = New System.Drawing.Size(264, 280)
        Me.lvwOrder.TabIndex = 2
        Me.lvwOrder.View = System.Windows.Forms.View.Details
        '
        'lstOrders
        '
        Me.lstOrders.Name = "lstOrders"
        Me.lstOrders.Size = New System.Drawing.Size(120, 277)
        Me.lstOrders.TabIndex = 0
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(464, 321)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lvwOrder, Me.lstOrders})
        Me.Name = "Form1"
        Me.Text = "XmlNodeReader"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_AllOrders As XmlDocument

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        lstOrders.SetBounds(0, 0, lstOrders.Size.Width, ClientSize.Height)
        lvwOrder.SetBounds(lstOrders.Size.Width, 0, ClientSize.Width - lstOrders.Size.Width, ClientSize.Height)
    End Sub

    ' Load the list of customer names.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim xml_node_reader As System.Xml.XmlNodeReader

        ' Load the document Orders.xml.
        m_AllOrders = New XmlDocument()
        m_AllOrders.Load(DataSubdirectory() & "\Orders.xml")

        ' Display the Orders' Customer names.
        lstOrders.Items.Clear()

        ' Assign an XmlNodeReader to the node.
        xml_node_reader = New System.Xml.XmlNodeReader( _
            m_AllOrders.DocumentElement)

        ' Process the nodes.
        Do Until xml_node_reader.EOF
            ' If this is an Order node, process it.
            If xml_node_reader.Name = "Name" Then
                lstOrders.Items.Add(xml_node_reader.ReadString())
            End If

            ' Get the next node.
            xml_node_reader.Read()
        Loop

        ' Create ListView headers.
        lvwOrder.Columns.Add("Item", 125, HorizontalAlignment.Left)
        lvwOrder.Columns.Add("Unit Price", 70, HorizontalAlignment.Right)
        lvwOrder.Columns.Add("Quantity", 70, HorizontalAlignment.Right)
        lvwOrder.Columns.Add("Total", 70, HorizontalAlignment.Right)
    End Sub

    ' Display information on the selected order.
    Private Sub lstOrders_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstOrders.SelectedIndexChanged
        Dim xml_node As XmlNode
        Dim xml_node_reader As System.Xml.XmlNodeReader
        Dim unit_price As Single
        Dim quantity As Single
        Dim grand_total As Single
        Dim lvw_item As ListViewItem

        ' Get the corresponding node.
        xml_node = m_AllOrders.DocumentElement.ChildNodes(lstOrders.SelectedIndex)

        ' Attach an XmlNodeReader to the Order subtree.
        xml_node_reader = New System.Xml.XmlNodeReader(xml_node)

        ' Process the subtree looking for item information.
        lvwOrder.Items.Clear()
        Do Until xml_node_reader.EOF
            ' If this is an Item, process this node.
            If xml_node_reader.Name = "Item" Then
                ' Get the unit price and quantity.
                unit_price = CSng(xml_node_reader.GetAttribute("UnitPrice"))
                quantity = CSng(xml_node_reader.GetAttribute("Quantity"))
                grand_total = grand_total + unit_price * quantity

                ' Display the values for this Item.
                lvw_item = lvwOrder.Items.Add(xml_node_reader.GetAttribute("ItemName"))
                lvw_item.SubItems.Add(Format$(unit_price, "$#,##0.00"))
                lvw_item.SubItems.Add(quantity.ToString)
                lvw_item.SubItems.Add(Format(unit_price * quantity, "$#,##0.00"))
                lvw_item.EnsureVisible()
            End If

            ' Get the next node in the Order.
            xml_node_reader.Read()
        Loop

        lvw_item = lvwOrder.Items.Add("")
        lvw_item = lvwOrder.Items.Add("")
        lvw_item.SubItems.Add("")
        lvw_item.SubItems.Add("Grand Total")
        lvw_item.SubItems.Add(Format(grand_total, "$#,##0.00"))
        lvw_item.EnsureVisible()
    End Sub

End Class
